From bfbdffa1cc138cf0cee9b71c7fd38aa8936f9b56 Mon Sep 17 00:00:00 2001
From: Jakob Leben <jakob@leptop.(none)>
Date: Fri, 31 Jul 2009 01:31:51 +0200
Subject: [PATCH] Qt4 playlist: disable dropping onto items which are not containers (nodes)

---
 .../gui/qt4/components/playlist/playlist_model.cpp |    9 ++++++++-
 1 files changed, 8 insertions(+), 1 deletions(-)

diff --git a/modules/gui/qt4/components/playlist/playlist_model.cpp b/modules/gui/qt4/components/playlist/playlist_model.cpp
index 6a47ad7..3f59ea5 100644
--- a/modules/gui/qt4/components/playlist/playlist_model.cpp
+++ b/modules/gui/qt4/components/playlist/playlist_model.cpp
@@ -116,8 +116,15 @@ Qt::DropActions PLModel::supportedDropActions() const
 Qt::ItemFlags PLModel::flags( const QModelIndex &index ) const
 {
     Qt::ItemFlags defaultFlags = QAbstractItemModel::flags( index );
+
     if( index.isValid() )
-        return Qt::ItemIsDragEnabled | Qt::ItemIsDropEnabled | defaultFlags;
+    {
+        playlist_item_t *p_item = playlist_ItemGetById( p_playlist, itemId( index ) );
+        if ( p_item->i_children > -1 )
+            return Qt::ItemIsDragEnabled | Qt::ItemIsDropEnabled | defaultFlags;
+        else
+            return Qt::ItemIsDragEnabled | defaultFlags;
+    }
     else
         return Qt::ItemIsDropEnabled | defaultFlags;
 }
-- 
1.6.0.4

